/*
 * 
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "compile.h"
#include "strutils.h"
#include "alfa.h"

char revobase[]="http://reta-vortaro.de/revo/art/"; //"http://purl.oclc.org/NET/voko/revo/art/";
char buf[8192], buf2[8192];
char s[256], addr[256], key0[256], key[256], key1[256], word[256], word0[256], gram[256];
char revo[256];
char ch1[8], ch2[8], ch3[8], oldch1[8], oldch2[8], oldch3[8];
char charname[5];
int first, col, dt, dd, it, li, mrk, sm, oe, tr, fs, sup, src, qu;
int oficiala, afikso;
int eop;
char path_info[256];
char path[256];
char Base[256];
char *suffix="html";
int splitno;
int searching;
int decimal=1;
int unicode=1;
int text=0;

extern alfacoll Alfa1,Alfa2,CAlfa,Srg1,Srg2,Subst;

char *spl[256];

// Kontrolu, cxu simbolo estas blanka
int _isspace(int c) {
  switch (c) {
    case ' ': case '\r': case '\n': case '\t': return 1;
    default: return 0;
  }
} //_isspace

int skipsp=1;

// Prenu simbolon, forigante superfluajn spacetojn
int getsym(void) {
  int c;
  static int oldc;

  for (;;) {
    c=getchar();
    if (c=='\r') continue;
    eop=feof(stdin) || (c==0) || (c=='\n' && oldc=='\n');
    if (eop) return 0;
    if (skipsp && _isspace(c) && _isspace(oldc)) {
      if (oldc!='\n') oldc=c;
      continue;
    }
    oldc=c;
    if (skipsp && _isspace(c)) c=' ';
    return c;
  }
} //getsym

// Preteru cxiujn blankajn simbolojn
char *skipspc(char *p) {
  while (_isspace(*p)) p++;
  return p;
} //skipspc

// Anstatauxigu a per b en komenco de litercxeno s
char *rep0(char *s, char *a, char *b) {
  register char *p;

  if (s==NULL) return NULL;
  if (strncmp(s,"(la) ",5)==0) s+=5;
  if (strncmp(s,"la ",3)==0) s+=3;

  p=strstr(s,a);
  if (p==NULL) return NULL;
  if (p>s && *(p-1)!=' ') return NULL;

  del(p,strlen(a));
  ins(p,b);

  return p;
} //rep0

int strxlen(char *s) {
  int n;

  n=0;
  while (*s) {
    if (*s!='x') n++;
    s++;
  }
  return n;
} //strxlen

// Prenu n unuajn literojn el cxeno s (atentante x-ojn)
void getnkey (char *p, char *s, int n) {
  char ss[MAXLEN];

  strcpy(ss,s);
  if (strncmp(s,"la ",3)==0) s+=3;

  if (*s=='(')
    while (*s && *s!=')') s++;
  if (*s==')') s++;
  while (*s==' ') s++;

  while (rep(ss,"-",""));
  while (rep(ss,",",""));
  while (rep(ss,"(",""));
  while (rep(ss,")",""));
  while (rep(ss,"/",""));
  while (rep(ss,"|",""));
  while (rep(ss,"*",""));
  while (rep(ss,"'",""));
  while (rep(ss,"`",""));

  toNKey(ss,&Srg1,n,p,NULL);
} //getnkey

// Prenu subcxenon gxis renkontigxis subcxeno end
void getseq(char *s, char **p, char *end) {
  while (**p) {
    if (strncmp(*p,end,strlen(end))==0) break;
    *s++=*(*p)++;
  }
  *s=0;
} //getseq

char *senkapa(char *s) {
  char ss[MAXLEN];

  toNKey(s,&Alfa1,1,NULL,ss);
  return s+strlen(ss);
} //senkapa

void tilde0(char *s) {
  rep(s,"\\~",senkapa(key0));
  rep(s,"~",key0);
} //tilde0

void tilde(char *s) {
  rep(s,"\\~",senkapa(key));
  rep(s,"~",key);
} //tilde

// Kalkulu adreson por hiperligo
void getaddr(char *addr, char *s) {
  char hdr[10],hdr1[10];
  char s1[256];
  char **sp;
  char *p;
  char ss[256];

  strcpy(s1,s);
  tilde(s); /*while (rep(s1,"~",key));*/

  getnkey(hdr,s1,1);
  getnkey(hdr1,s1,3);

  for (sp=spl; *sp; sp++)
      if (strncmp(hdr,*sp,strlen(hdr))==0) break;
  for (; *sp && **sp!='.'; sp++)
      if (strncmp(hdr1,*sp,strlen(hdr1))<0) break;
  if (*sp && sp!=spl) {
    sp--;
    if (**sp!='.') strcpy(hdr,*sp);
  }

  while (rep(s1,".",""));
  toKey(s1,&Srg1,ss);
  if (text)
    sprintf(addr,"#%s",ss);
  else
    sprintf(addr,"%s.%s#%s",hdr,suffix,ss);
  while (rep(addr," ","_"));
  while (rep(addr,"(",""));
  while (rep(addr,")",""));
  while (rep(addr,"-","_0"));
} //getaddr

// Kalkulu adreson por marko
void getanch(char *addr, char *s) {
  char *p;
  char ss[256];

  p=s;
  if (strncmp(p,"la ",3)==0) p+=3;
  if (*p=='(')
    while (*p && *p!=')') p++;
  if (*p==')') p++;
  while (*p==' ') p++;

  strcpy(addr,p);

  if (*addr==0) {
    if (li) sprintf(addr,"%s %d",word,li);
    else strcpy(addr,word);
  }

  while (rep(addr,"(",""));
  while (rep(addr,")",""));
  while (rep(addr,"/",""));
  while (rep(addr,"|",""));
  while (rep(addr,"%",""));
  while (rep(addr,"\x01",""));
  while (rep(addr,"\x02",""));
  //while (rep(addr,"_",""));
  while (rep(addr,",",""));
  while (rep(addr,".",""));
  while (rep(addr,"'",""));
  while (rep(addr,"*",""));
  //while (rep(addr,"@",""));
  while (rep(addr,"!",""));
  while (rep(addr," ","_"));
  while (rep(addr,"-","_0"));
  tilde(addr);    //rep(addr,"~",key);

  toKey(addr,&Srg1,ss);
  strcpy(addr,ss);

} //getanch

void wrdcpy(char *word, char *s) {
  char *p,*pp;
  for (p=s, pp=word; *p;) {
    if (*p!='@')
      *pp++=*p++;
    else break;
  }
  *pp=0;
} //wrdcpy

// Konservu du- kaj triliterajn markojn
void savekey (char *s) {
  char *p;

  if (strncmp(s,"la ",3)==0) s+=3;
  if (*s=='(')
    while (*s && *s!=')') s++;
  if (*s==')') s++;
  while (*s==' ') s++;

  while (rep(s,"*",""));
  //while (rep(s,"-",""));
  while (rep(s,"%",""));
  //while (rep(s,"@",""));
  while (rep(s,"&",""));
  while (rep(s,"!",""));
  while (rep(s,".",""));
  while (rep(s,"\x01",""));
  while (rep(s,"\x02",""));
  while (rep(s,"\\",""));
  for (p=s; *p; p++)
    if (*p==' ') {
      *p=0; break;
    }

  p=strchr(s,'|');
  if (p)
    *p=0;
  else {
    p=s+strlen(s)-1;
    while (p>s && strcmp(p,"/o") && strcmp(p,"/a")
               && strcmp(p,"/e") && strcmp(p,"/i")) --p;
    if (*p=='/') *p=0;
  }

  p=strchr(s,'|');
  if (p) *p=0;
  wrdcpy(key1,s);
  while (rep(key1,"/",""));
  while (rep(s,"-",""));
  wrdcpy(key0,s);
  while (rep(s,"/",""));
  wrdcpy(key,s);

  if (splitno==0)
    getnkey(charname,key,1);
  getnkey(ch1,key,1);
  getnkey(ch2,key,2);
  getnkey(ch3,key,3);
} //savekey

// Konservu kurantan vorton
void saveword(char *s) {
  wrdcpy(word,s);

  while (rep(word,"/",""));
  while (rep(word,"*",""));
  strcpy(word0,word);
  tilde(word0);
  while (rep(word0,"|",""));

  while (rep(word,"-",""));
  while (rep(word,"@",""));
  while (rep(word,"!",""));
  while (rep(word," ","_"));
  //while (rep(word," ",""));
  tilde(word); /*while (rep(word,"~",key));*/
} //saveword

// Kontrolu gramatikajn indikojn
static char *_checkgr (char **p) {
  char *pp,*ppp;
  pp = *p-1;
  if (*pp!=' ') pp++;
  if (match(p,"_vt_") ||
      match(p,"_vn_") ||
      match(p,"_vn +i_") ||
      match(p,"_vt +i_") ||
      match(p,"_vt, vn_") ||
      match(p,"_vn, vt_") ||
      match(p,"_vt, vn +i_") ||
      match(p,"_vn, vt +i_")) {
    ppp=gram;
    while (*pp && pp<*p) *ppp++ = *pp++;
    *ppp=0;
    return gram;
  }
  return NULL;
} //checkgr

int _isw(char c) {
  if (c=='~' || c=='.' || c=='-' || c=='|' || c=='/' || c=='(' || c==')'
             || 'a'<=c && c<='z' || 'A'<=c && c<='Z' || c=='@' || c=='\''
             || c=='\x01' || c=='\x02' || c=='\\')
    return 1;
  else
    return 0;
} //_isw

static void _begArt(void)       {printf("<dl>");}
static void _endArt(void)       {printf("\n</dl>\n");}
static void _begQuote (void) {
  if (unicode)
    printf("&laquo;");
  else
    printf("\"");
}
static void _endQuote (void) {
  if (unicode)
    printf("&raquo;");
  else
    printf("\"");
}
static void _begCapt (void)       {printf("\n<dt>");}
static void _endCapt(void)        {printf("\n</dt>");}
static void _begTr(void)          {printf("\n<dd>");}
static void _endTr(void)          {printf("\n</dd>");}
static void _begOrigExample(void) {printf("<span class=\"oe\">");}
static void _endOrigExample(void) {printf("</span>");}
static void _begExample(void)     {printf("<small>");}
static void _endExample(void)     {printf("</small>");}
static void _begAccent(void)      {printf("<em>");}
static void _endAccent(char c) {
/*  if (strchr("AEIOU",c))
    printf("<em><em>&#769;</em></em></em>");
  else
    printf("<em>&#769;</em></em>");
*/
  //printf("&#769;</em>");
  printf("</em>");
}
static void _begItal(void)        {printf("<i>");}
static void _endItal(void)        {printf("</i>");}
static void _begFound(void)       {printf("<span class=\"found\">");}
static void _endFound(void)       {printf("</span>");}
static void _begChanged(void)     {printf("<span class=\"changed\">");}
static void _endChanged(void)     {printf("</span>");}
static void _begStrike(void)      {printf("<s>");}
static void _endStrike(void)      {printf("</s>");}
static void _begSup(void)         {printf("<sup>");}
static void _endSup(void)         {printf("</sup>");}
static void _begSrc(void)         {printf("<sup>");}
static void _endSrc(void)         {printf("</sup>");}
static void _begOl(void)          {printf("\n<ol>");}
static void _endOl(void)          {printf("\n</ol>");}
static void _begLi(void)          {printf("\n<li>");}
static void _endLi(void)          {printf("\n</li>");}
static void _putMark(char *addr)  {printf("<a id=\"%s\" name=\"%s\"></a>",addr,addr);}
static void _begRef(char *addr)   {printf("<a href=\"%s%s\">",Base,addr);}
static void _endRef(void)         {printf("</a>");}
static void _putBr(void)          {printf("<br />\n");}
static void _putDash(void)        {if (unicode) printf("&#8211;"); else printf("--");}
static void _putArr(void)         {printf("=&gt;");}
static void _putEqu(void)         {printf("=");}
static void _putHr(void)          {printf("\n<hr />\n\n");}

static void _putTilde(char *ss, int n) {
  char s[256];
  char *p;

  strncpy(s,ss,n);
  s[n]=0;

  tilde(s);

  ins(s,"<span class=\"rad\">");
  strcat(s,"</span>");
  while (rep(s,"<span class=\"rad\"> "," <span class=\"rad\">"));
  while (rep(s," </span>","</span> "));
  p=s;
  while (*p) putsym(&p);
} //_putTilde

static int _userMatch (char **p)    { return 0; }

char *(*checkgr) (char **p)= _checkgr;
void (*begArt)(void)    =_begArt;
void (*endArt)(void)    =_endArt;
void (*putHr)(void)     =_putHr;
void (*begQuote) (void) =_begQuote;
void (*endQuote) (void) =_endQuote;
void (*begCapt)(void)   =_begCapt;
void (*endCapt)(void)   =_endCapt;
void (*begTr)(void)     =_begTr;
void (*endTr)(void)     =_endTr;
void (*begExample)(void)=_begExample;
void (*endExample)(void)=_endExample;
void (*begOrigExample)(void)=_begOrigExample;
void (*endOrigExample)(void)=_endOrigExample;
void (*begAccent)(void) =_begAccent;
void (*endAccent)(char c) =_endAccent;
void (*begItal)(void)   =_begItal;
void (*endItal)(void)   =_endItal;
void (*endFound)(void)  =_endFound;
void (*begFound)(void)  =_begFound;
void (*begChanged)(void)=_begChanged;
void (*endChanged)(void)=_endChanged;
void (*begStrike)(void) =_begStrike;
void (*endStrike)(void) =_endStrike;
void (*begSup)(void)    =_begSup;
void (*endSup)(void)    =_endSup;
void (*begSrc)(void)    =_begSrc;
void (*endSrc)(void)    =_endSrc;
void (*begOl)(void)     =_begOl;
void (*endOl)(void)     =_endOl;
void (*begLi)(void)     =_begLi;
void (*endLi)(void)     =_endLi;
void (*putMark)(char *addr)=_putMark;
void (*begRef)(char *addr)=_begRef;
void (*endRef)(void)    =_endRef;
void (*putBr)(void)     =_putBr;
void (*putDash)(void)   =_putDash;
void (*putArr)(void)    =_putArr;
void (*putEqu)(void)    =_putEqu;
void (*putTilde)(char *ss, int n)=_putTilde;
int (*userMatch)(char **p)=_userMatch;

static void _putword (char **p) {
  char w[256];
  char *pp;
  char *s, *ss, *end, *k0;
  char c;
  static char old[10][256];
  int i,lnk;


  if (!_isw(**p)) {
    putsym(p);
    return;
  }

  revo[0]=0;
  for (pp=w; _isw(**p) || **p==' '; (*p)++) {
    if (**p=='@') {
      char *r=revo;
      *pp=0;
      (*p)++;
      while (**p && **p!=',' && **p!=']' && **p!='!')
        *r++=*(*p)++;
      *r=0;
      break;
    }
    if (strncmp(*p,"\\~",2)==0) {
      *pp++ = *(*p)++;
      *pp++ = **p;
      *pp=0;
      tilde0(w);
      pp=w+strlen(w);
      if (_isw((*p)[1]))
        *pp++='/';
    }
    else if (**p=='~') {
      *pp++ = **p;
      *pp=0;
      tilde0(w);
      pp=w+strlen(w);
      if (_isw((*p)[1]))
        *pp++='/';
    }
    else
      *pp++ = **p;
  }
  *pp=0;
  if (pp[-1]==' ') {
    --pp;
    *pp=0;
  }

  getanch(addr,w);

  while (rep(revo,"!",""));

  lnk=revo[0]!=0;
  buf2[0]=0;

  if (lnk) {
    /*pp=strchr(revo,'.');
    strcpy(buf2,"/cgi-bin/revo?");
    if (pp) *pp=0;
    strcat(buf2,revo);
    if (pp) *pp='.';
    strcat(buf2,"#");
    strcat(buf2,revo);*/

    strcpy(buf2,revobase);
    pp=strchr(revo,'.');
    if (pp) *pp=0;
    strcat(buf2,revo);
    strcat(buf2,".html#");
    if (pp) *pp='.';
    strcat(buf2,revo);
  }

  for (i=0; i<10; i++) {
    if (strcmp(old[i],addr)==0) {
      strcat(addr,"_");
      break;
    }
  }

  printf("<a id=\"%s\" name=\"%s\"",addr,addr);
  if (lnk)
    printf(" target=\"revo\" href=\"%s\">",buf2);
  else
    printf(">");
  if (!lnk) printf("</a>");
  for (i=8; i>=0; i--)
    strcpy(old[i+1],old[i]);
  strcpy(old[0],addr);

  pp=strrchr(w,'|');
  if (pp==NULL)
    pp=strrchr(w,'/');
  if (pp)
    *pp=oficiala?'*':'/';
  else if (oficiala)
    strcat(w,"*");

  while (rep(w," I*","* I"));
  while (rep(w," II*","* II"));
  while (rep(w," III*","* III"));

  while (rep(w,"//","/"));
  while (rep(w,"/'","'"));

  if (unicode) while (rep(w,"/","&#183;"));
  oficiala=0;

  for (pp=w; *pp; )
    if (match(&pp,"\x01")) {
      begFound();
      tr=1;
    }
    else if (match(&pp,"\x02")) {
      endFound();
      tr=0;
    }
    else
      putsym(&pp);

  if (lnk) printf("</a>");
} //_putword

void (*putword)(char **p)=_putword;

int nestoj=0, radikoj=0, counter=0;
int indekse=1;

/* Kompilu paragrafon (vortaran neston)*/
void compile(void) {
  char *p,*pp,*q,*a;
  char c;
  int it1, ekz1;

  if (buf[strlen(buf)-1]==' ')
    buf[strlen(buf)-1]=0;
  while(rep(buf,"\r",""));
  while(rep(buf," \n","\n"));
  while(rep(buf,"\n ","\n"));
  while(rep(buf," #","#"));

  p=buf;
  first=1;
  dt=dd=it=tr=li=sm=oe=fs=col=mrk=sup=src=ekz1=qu=0;
  afikso=0;

  while (*p) {
    if (sm && match(&p,"[")) {
      begOrigExample();
      oe=1;
    }
    else if (match(&p,"[")) { //tradukata vorto
      pp=p; nestoj++;
      getseq(s,&pp,"]");
      saveword(s);
      if (dt) fprintf(stderr,"Eraro: '%s' [\n",key);
      if (first) {       //kapvorto
        a=strpbrk(s,"/|");
        if (indekse && (a==NULL || *a=='|')) radikoj++;
        savekey(s);
        split();
        putHr();
        begArt();
        begCapt();
        if (word0[0]=='-' || word0[strlen(word0)-1]=='-') afikso=1;
        else afikso=0;
      }

      if (li) {        //cxesigu numeritan liston
        endLi();
        endOl();
        li=0;
      }

      if (!first) {
        endTr();
        begCapt();
      }

      first=0;
      dt=1; dd=0;
      oficiala=0;
      ekz1=0;
    }
    if (sm && match(&p,"]")) {
      endOrigExample();
      oe=0;
    }
    else if (match(&p,"]")) { //komenco de tradukajxo
      if (dd || !dt) fprintf(stderr,"Eraro: '%s' ]\n",key);
      //printf("</b>"); //!!!
      p=skipspc(p);
      pp=checkgr(&p);
      if (pp) {  //gramatika indiko
        it1=0;
        while (*pp) {
          if (*pp!='_')
            putsym(&pp);
          else {
            if (it1)
              endItal();
            else
              begItal();
            it1=!it1;
            pp++;
          }
        }
      }
      //printf(" %s",pp);
      endCapt();
      begTr();
      dt=0; dd=1;
    }
    else if (match(&p,"{")) {   //komenco de ekzemplo
      begExample();
      sm=1;
    }
    else if (match(&p,"}")) {   //fino de ekzemplo
      endExample();
      sm=0;
    }
    else if (match(&p,"--"))    //longa streketo
      putDash();
    else if (match(&p,"=>"))    //prefero
      putArr();
    else if (match(&p,"="))     //sinonimo
      putEqu();
    else if (match(&p,"``")) {  //nepra akcento
      c=*p;
      begAccent();
      putsym(&p);
      endAccent(c);
    }
    else if (match(&p,"`")) {   //akcento
      c=*p;
      begAccent();
      putsym(&p);
      endAccent(c);
    }
    else if (match(&p,"_")) {   //klino
      if (it) {
        endItal();
        it=0;
        if (*(p-2)==':') ekz1=1;
      }
      else {
        begItal();
        it=1;
      }
    }
    else if (match(&p,"\x01")) {   //trovita teksto
      begFound();
      tr=1;
    }
    else if (match(&p,"\x02")) {   //trovita teksto
      endFound();
      tr=0;
    }
    else if (match(&p,"%")) {    //sxangxita aux aldonita teksto
      if (col) {
        endChanged();
        col=0;
      }
      else {
        begChanged();
        col=1;
      }
    }
    else if (match(&p,"\"")) {   //citilo
      if (qu) {
        endQuote();
        qu=0;
      }
      else {
        begQuote();
        qu=1;
      }
    }
    else if (match(&p,"&#")) {
      printf("&#");
      while (*p!=';')
        putsym(&p);
    }
    else if (match(&p,"#")) {   //numerita linio
      if (li) {
        endLi();
        begLi();
      }
      else {
        begOl();
        begLi();
      }
      li++;
      getanch(addr,"");
      putMark(addr);
    }
    else if (match(&p,"<*")) {   //supren
      sup=1;
      begSup();
      if (*p=='-') {
        printf(" ");
        if (unicode) {
          putDash();
          p++;
        }
      }
    }
    else if (match(&p,"*>")) {   //malsupren
      sup=0;
      endSup();
    }
    else if (match(&p,"(*")) {   //fontindiko
      src=1;
      begSrc();
    }
    else if (match(&p,"*)")) {   //fino de fontindiko
      src=0;
      endSrc();
    }
    else if (match(&p,"<")) {    //komenco de referenco
      getseq(s,&p,">");
      getaddr(addr,s);
      begRef(addr);
      for (q=s; *q; ) putsym(&q); //printf("%s",s);
    }
    else if (match(&p,">"))     /*fino de referenco*/
      endRef();
    else if (dd && isalpha(*p) && p[1]=='x' && p[2]=='\\' && p[3]=='~') {  //tildo
      putTilde(p,4);
      p+=4;
    }
    else if (dd && isalpha(*p) && p[1]=='\\' && p[2]=='~') {   //tildo
      putTilde(p,3);
      p+=3;
    }
    else if (dd && *p=='~') {  //tildo
      putTilde(p,1);
      p++;
    }
    else if (match(&p,";")) {
      printf(";");
      if (!sm && !it && !ekz1) {
        pp=skipspc(p);
        if (*pp && *pp!='#' && *pp!='[') {
          putBr();
          p=pp;
        }
      }
    }
    else if (match(&p,"$"))
      putBr();
    /*else if (match(&p,"|"))
      printf("||");*/
    else if (match(&p,"*"))
      oficiala=1;
    else {
      userMatch(&p);
      if (dt)
        putword(&p);
      else
        putsym(&p);
    }
  }
  if (li) {
    endLi();
    endOl();
  }
  if (!first) {endTr(); endArt();}
  if (!searching) {
    if (dt || it || tr || sm || oe || fs || col || mrk || sup || src || qu) {
      fprintf(stderr,"Eraro: '%s' ",key);
      if (dt) fprintf(stderr,"[ ");
      if (it) fprintf(stderr,"_ ");
      if (tr) fprintf(stderr,"& ");
      if (sm) fprintf(stderr,"{ ");
      if (fs) fprintf(stderr,"\\ ");
      if (col) fprintf(stderr,"%% ");
      if (mrk) fprintf(stderr,"@ ");
      if (sup) fprintf(stderr,"<* ");
      if (src) fprintf(stderr,"(* ");
      if (qu) fprintf(stderr,"\"");
      fprintf(stderr,"\n");
    }
  }
} //compile

void fputsym(FILE *f, char **p) {
  char s[MAXLEN],ss[MAXLEN],s1[MAXLEN],c;

  if (**p==' ') {
    fprintf(f,"%c",*(*p)++);
    return;
  }

  s[0]=ss[0]=0;
  toNKey(*p,&Subst,1,s,ss);
  if (ss[0]) {
    fprintf(f,"%s",s);
    (*p)+=strlen(ss);
  }
  else
    fprintf(f,"%c",*(*p)++);
}

void putsym(char **p) {
  fputsym(stdout,p);
}

void fputStrUni (FILE *f, char *p) {
  char **pp;

  pp=&p;
  while (**pp)
    fputsym(f,pp);
} //fputStrUni
